;-------------------------------------------------------------------------------------------;
;     		File:       wrfel_casino.a51    	                                            ;
;     		Autor:      AdrianChKh		            		Klasse:   TGT12/2                  ;
;     		Controller: AT89C5131 (Atmel)                                                   ;
;   		   Datum:      08.12.2011 - 19.01.2012    		Version:  3.2.7                    ;
;-------------------------------------------------------------------------------------------;

				include 5131.inc           ;Adresse der Ports einbinden
				cseg								;Programm fr
				org 0                      ;die Speicheradresse 0

				mov dptr,#tabelle				;hole Tabellen-Offset
				mov r4,#00h                ;lsche das erste Merkregister
				mov r5,#00h                ;lsche das zweite Merkregister
				mov p0,#00h                ;lsche die rechte
				mov p2,#00h						;und die linke Anzeige
start:		jb p3.2,ondelay				;mache das Programm "an" wenn
				jb p3.3,ondelay            ;eine der beiden Taster gedrckt ist
				ljmp start                 ;ansonsten, bleibe "aus"
ondelay:		mov r1,#255						;255mal Vorgang ausfhren
ondelay1:	mov r0,#255                ;255^2mal ausfhren
ondelay2:	djnz r0,ondelay2           ;erster Zhler
				djnz r1,ondelay1           ;zweiter Zhler
				ljmp anfang						;wenn runtergezhlt ist, springe auf anfang

anfang:		mov r2,#0                  ;speichere die Schrich-Zahl ins rechte-Zahl-Register
				mov r3,#0                  ;speichere die Schrich-Zahl ins linke-Zahl-Register
				clr p0.0                   ;lsche den rechten
				clr p2.0							;und den linken Punkt
on1:			lcall movr                 ;gebe den inhalt vom Register rechts an
				lcall movl                 ;gebe den inhalt vom Register rechts an
				ljmp zeita                 ;Zeitkonstante mit Sprungmglichkeit
off1:			lcall movz                 ;lche alle Zahlen der Anzeige
				ljmp zeita                 ;Zeitkonstante mit Sprungmglichkeit
				
dice:			clr p0.0                   ;lsche den rechten
				clr p2.0							;und den linken Punkt
				mov r0,#35						;setzte das erste und zweite Zhlregister
				mov r1,#35                 ;auf 35 (fr spter)
				mov r7,#4                  ;schriebe ersten Zyklusteil ins Rechenregister
				mov a,r4                   ;hole das erste Merkregister in den Akku
				orl a,#80h                 ;setze das erste Bit auf 1
				anl a,#0F7h						;und das fnfte Bit auf 0
				mov r4,a                   ;schreibe die Zahl wieder zurck
				mov a,r5							;hole das zweite Merkregister in den Akku
				anl a,#7Fh                 ;lsche das leftcontrolbit 
				mov r5,a                   ;und schreibe die Zahl wieder zurck
				mov a,r6							;hole die Spieleinstellungen
				anl a,#80h                 ;maskiere alles auer dem ersten Bit
				jnz jdice1                 ;wenn es 1 ist, starte dice1
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#40h                 ;maskiere alles auer dem zweiten Bit
				jnz jdice2                 ;wenn es 1 ist, starte dice2
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#20h                 ;maskiere alles auer dem dritten Bit
				jnz jdice3                 ;wenn es 1 ist, starte dice3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#10h                 ;maskiere alles auer dem vierten Bit
				jnz jdice1                 ;wenn es 1 ist, starte dice1
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#08h                 ;maskiere alles auer dem fnften Bit
				jnz jdice2                 ;wenn es 1 ist, starte dice2
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#04h                 ;maskiere alles auer dem sechsten Bit
				jnz jdice3                 ;wenn es 1 ist, starte dice3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#02h                 ;maskiere alles auer dem siebten Bit
				jnz jdice3                 ;wenn es 1 ist, starte dice3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#01h                 ;maskiere alles auer dem achten Bit
				jnz jdice2                 ;wenn es 1 ist, starte dice2
jdice1:		ljmp dice1                 ;berbrckung
jdice2:		ljmp dice2						;berbrckung
jdice3:		ljmp dice3						;berbrckung
				
dice1:		mov p2,#00h						;lsche die linke Anzeige
				mov a,r5                   ;hole das zweite Merkregister
				orl a,#80h                 ;setze das leftcontrolbit
				mov r5,a							;und schreibe die Zahl wieder zurck
neu1:			mov r2,#6                  ;schreibe hchstmgliches Ergebnis ins Register
				nop                        ;warte (Zeitausgleich)
loop1:		lcall muster               ;Drehmuster weitermachen
				lcall punkt                ;setze die Punkte wenn gewollt
				jb p3.2,next1              ;ist der linke Taster gedrckt?
				clr p2.0                   ;wenn nein, lsche den linken Punkt
next1:		jb p3.3,counter1           ;ist der rechte Taster gedrckt?
				jb  p0.0,jstop1            ;wenn nein, stoppe wenn rechter Punkt an ist
counter1:	dec r2                     ;verringere die Zahl um 1
				mov a,r2                   ;und schreibe es in den Akku
				jz neu1                    ;um nachzusehen, ob es "0" ist
				ljmp loop1                 ;andernfalls, nochmal machen
jstop1:		lcall movr						;gebe die rechte Zahl aus
				ljmp stop						;berbrckung
						
dice2:		mov a,r4                   ;hole das erste Merkregister in den Akku
				anl a,#7Fh                 ;lsche das das erste Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				mov p2,#00h						;lsche die linke Anzeige
restart2:	mov r3,#6						;schreibe hchstmgliches Ergebnis ins Register
				nop                        ;warte (Zeitausgleich)
				nop                        ;warte (Zeitausgleich)
				nop                        ;warte (Zeitausgleich)
				nop                        ;warte (Zeitausgleich)
				nop                        ;warte (Zeitausgleich)
				nop                        ;warte (Zeitausgleich)
neu2:			mov r2,#6                  ;schreibe hchstmgliches Ergebnis ins Register
loop2:		lcall muster               ;Drehmuster weitermachen
				lcall punkt                ;setze die Punkte wenn gewollt
				jnb p0.0,next2             ;ist der rechte Punkt an
				jnb p3.3,jstop2            ;und der rechte Taster nicht gedrckt, stoppe
next2:		jnb p2.0,counter2          ;ist der linke Punkt an
				jnb p3.2,jstop2            ;und der linke Taster nicht gedrckt, stoppe
counter2:	djnz r2,oneend2            ;ist die Zahl um 1 grer als 0
				dec r3                     ;und die linke Zahl,
				mov a,r3                   ;wenn man sie um 1 verringert "0" ist
				jz restart2                ;setzte beide Zahlen wieder auf "6"
				inc r3                     ;wenn nicht erhhe die linke Zahl wieder
oneend2:		inc r2                     ;genau so wie die rechte Zahl
				djnz r2,noend2             ;verringere die rechte Zahl und wenn sie 0 ist,
				dec r3                     ;verringere die linke
				ljmp neu2                  ;und setze die rechte Zahl wieder auf "6"
noend2:		ljmp filler2               ;Sprung zur nchsten Zeile (Zeitausgleich)
filler2:		ljmp loop2                 ;machs nochmal
jstop2:		lcall movr						;gebe die rechte und
				lcall movl                 ;die linke Zahl aus
				ljmp stop						;berbrckung
                                     
dice3:		mov a,r4                   ;hole das erste Merkregister in den Akku
				anl a,#7Fh                 ;lsche das das erste Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				mov r2,#6						;schreibe hchstmgliches Ergebnis ins Register
				mov r3,#6						;schreibe hchstmgliches Ergebnis ins Register
part1:		lcall muster               ;Drehmuster weitermachen
				lcall punkt						;setze die Punkte wenn gewollt
				jnb p0.0,p1checker         ;ist der rechte Punkt an
				jb p3.3,p1checker          ;und der rechte Taster nicht gedrckt,
				clr p0.0                   ;mache den rechten Punkt aus
				mov a,r4                   ;hole das erste Merkregister
				anl a,#08h                 ;konzentriere dich auf das "rihgtbit"
				jnz p1checker					;wenn es 0 ist,
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,p12janfang       ;und vergleiche sie mit den PINs, bei gleichheit:
				mov a,r4                   ;nehme das erste Merkregister
				orl a,#08h                 ;und setze das fnfte Bit auf 1
				mov r4,a                   ;und schreibe es wieder ins Register
				lcall movr						;und gebe die gewrfelte Zahl aus
p1checker:	mov a,r4                   ;nehme das erste Merkregister
				anl a,#08h                 ;konzentriere dich auf das fnfte Bit
				jnz part2                  ;berspringe den Zhler, wenn es 1 ist
				dec r2                     ;verringere die Zahl um 1
				mov a,r2                   ;und schreibe sie in den Akku
				jz p1reset			         ;um nachzusehen, ob sie "0" ist
				ljmp part2                 ;wenn sie "1" ist, berspringe den Rcksetzer
p1reset:		mov r2,#6                  ;setzte wieder die "6" ins linke-Zahl-Register
				nop		                  ;warte (Zeitausgleich)
part2:		lcall muster					;Drehmuster weitermachen
				lcall punkt						;setze die Punkte wenn gewollt
				jnb p2.0,p2checker         ;ist der linke Punkt an
				jb p3.2,p2checker          ;und der linke Taster nicht gedrckt,
				clr p2.0                   ;mache den linken Punkt aus
				mov a,r4                   ;hole das erste Merkregister
				anl a,#80h                 ;konzentriere dich auf das "rihgtbit"
				jnz p2checker					;wenn es 0 ist,
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,p12janfang       ;und vergleiche sie mit den PINs, bei gleichheit:
				mov a,r4                   ;nehme das erste Merkregister
				orl a,#80h                 ;und setze das erste Bit auf 1
				mov r4,a                   ;und schreibe es wieder ins Register
				lcall movl						;und gebe die gewrfelte Zahl aus
p2checker:	mov a,r4							;nehme das erste Merkregister
				anl a,#80h                 ;konzentriere dich auf das erste Bit
				jz p2counter               ;wenn es "0" ist, mache weiter wie gewohnt
				mov a,r4                   ;wenn nicht, nehme das erste Merkregister
				anl a,#08h                 ;und konzentriere dich auf das fnfte Bit
				jz p2jpart3                ;wenn das "0" ist, berspringe den Counter
				ljmp p2jstop3              ;wenn nicht, stoppe 
p2counter:	dec r3                     ;verringere die Zahl um 1
				mov a,r3                   ;und schreibe sie in den Akku
				jz p2reset			         ;um nachzusehen, ob sie "0" ist				
				ljmp p2jpart3              ;wenn nicht, springe zum nchsten Part
p2reset:		mov r3,#6						;wenn ja, dann schreibe die "6" ins Register
				nop                        ;warte (Zeitausgleich)
p2jpart3:	ljmp part3						;berbrckung
p2jstop3:   lcall movr						;gebe die rechte und
				lcall movl                 ;die linke Zahl aus
				ljmp stop						;berbrckung
p12janfang:	ljmp anfang						;berbrckung

part3:		lcall muster               ;Drehmuster weitermachen
				lcall punkt						;setze die Punkte wenn gewollt
				jnb p0.0,p3checker         ;ist der rechte Punkt an
				jb p3.3,p3checker          ;und der rechte Taster nicht gedrckt,
				clr p0.0                   ;mache den rechten Punkt aus
				mov a,r4                   ;hole das erste Merkregister
				anl a,#08h                 ;konzentriere dich auf das "rihgtbit"
				jnz p3checker					;wenn es 0 ist,
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,p34janfang       ;und vergleiche sie mit den PINs, bei gleichheit:
				mov a,r4                   ;nehme das erste Merkregister
				orl a,#08h                 ;und setze das fnfte Bit auf 1
				mov r4,a                   ;und schreibe es wieder ins Register
				lcall movr						;und gebe die gewrfelte Zahl aus
p3checker:	mov a,r4                   ;nehme das erste Merkregister
				anl a,#08h                 ;konzentriere dich auf das fnfte Bit
				jnz part4                  ;berspringe den Zhler, wenn es 0 ist
				dec r2                     ;verringere die Zahl um 1
				mov a,r2                   ;und schreibe sie in den Akku
				jz p3reset			         ;um nachzusehen, ob sie "0" ist
				ljmp part4                 ;wenn sie "1" ist, berspringe den Rcksetzer
p3reset:		mov r2,#6                  ;setzte wieder die "6" ins linke-Zahl-Register
				nop		                  ;warte (Zeitausgleich)
part4:		lcall muster					;Drehmuster weitermachen
				lcall punkt						;setze die Punkte wenn gewollt
				jnb p2.0,p4checker         ;ist der linke Punkt an
				jb p3.2,p4checker          ;und der linke Taster nicht gedrckt,
				clr p2.0                   ;mache den linken Punkt aus
				mov a,r4                   ;hole das erste Merkregister
				anl a,#80h                 ;konzentriere dich auf das "rihgtbit"
				jnz p4checker					;wenn es 0 ist,
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,p34janfang       ;und vergleiche sie mit den PINs, bei gleichheit:
				mov a,r4                   ;nehme das erste Merkregister
				orl a,#80h                 ;und setze das erste Bit auf 1
				mov r4,a                   ;und schreibe es wieder ins Register
				lcall movl						;und gebe die gewrfelte Zahl aus
p4checker:	mov a,r4							;nehme das erste Merkregister
				anl a,#80h                 ;konzentriere dich auf das erste Bit
				jz p4counter               ;wenn es "0" ist, mache weiter wie gewohnt
				mov a,r4                   ;wenn nicht, nehme das erste Merkregister
				anl a,#08h                 ;und konzentriere dich auf das fnfte Bit
				jz p4jpart1	               ;wenn das "0" ist, berspringe den Counter
				ljmp p4jstop3              ;wenn nicht, stoppe 
p4counter:	nop	                     ;Versinnlosung von part4
				mov a,r3                   ;und schreibe sie in den Akku
				jz p4reset			         ;um nachzusehen, ob sie "0" ist				
				ljmp p4jpart1              ;wenn nicht, springe zum nchsten Part
p4reset:		mov r3,#6						;wenn ja, dann schreibe die "6" ins Register
				nop                        ;warte (Zeitausgleich)
p4jpart1:	ljmp part1						;berbrckung
p4jstop3:	lcall movr						;gebe die rechte und
				lcall movl                 ;die linke Zahl aus
				ljmp stop	               ;berbrckung
p34janfang:	ljmp anfang						;berbrckung

stop:			mov r1,#49                 ;49mal Vorgang wiederholen
stloop:		lcall zeit                 ;Zeitverzgerung mit Setzmglichkeit
				jb p3.2,staskl             ;wenn der rechte Taster nicht mehr gedrckt ist,
				clr p2.0                   ;lsche den rechten Punkt
staskl:		jb p3.3,stcounter          ;wenn der linke Taster nicht mehr gedrckt ist,
				clr p0.0                   ;lsche den linken Punkt
stcounter:	djnz r1,stloop					;49x(200x10s+11s)=0,1s
				clr p0.0							;lsche den rechten
				clr p2.0	                  ;und den linken Punkt
				mov a,r4							;nehme die Zahl aus dem Register
				anl a,#77h                 ;setze das erste und das fnfte Bit zurck
				mov r4,a                   ;schreibe sie wieder ins Register
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,noteqal1         ;und vergleiche sie mit den PINs, bei gleichheit:
				mov a,r6							;hole die Spieleinstellungen
				anl a,#80h                 ;maskiere alles auer dem ersten Bit
				jnz rstop7                 ;wenn es 1 ist, starte stop7
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#40h                 ;maskiere alles auer dem zweiten Bit
				jnz rstop6                 ;wenn es 1 ist, starte stop6
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#20h                 ;maskiere alles auer dem dritten Bit
				jnz rstop5                 ;wenn es 1 ist, starte stop5
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#10h                 ;maskiere alles auer dem vierten Bit
				jnz rstop4                 ;wenn es 1 ist, starte stop4
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#08h                 ;maskiere alles auer dem fnften Bit
				jnz rstop3                 ;wenn es 1 ist, starte stop3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#04h                 ;maskiere alles auer dem sechsten Bit
				jnz rstop2                 ;wenn es 1 ist, starte stop2	
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#02h                 ;maskiere alles auer dem siebten Bit
				jnz rstop1                 ;wenn es 1 ist, starte stop1	
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#01h                 ;maskiere alles auer dem achten Bit
				jnz rstop0                 ;wenn es 1 ist, starte stop0
noteqal1:	ljmp anfang                ;berbrckung
rstop7:		ljmp stop7						;berbrckung (ein Wrfel)
rstop6:		ljmp stop6						;berbrckung (zwei Wrfel)	
rstop5:		ljmp stop5						;berbrckung (zwei Gegenwrfel)	
rstop4:		ljmp stop4						;berbrckung (ein Wrfel [selbe Ergebnis])	
rstop3:		ljmp stop3						;berbrckung (zwei Wrfel [selbe Ergebnis])		
rstop2:		ljmp stop2						;berbrckung (zwei Gegenwrfel [selbe Ergebnis])		
rstop1:		ljmp stop1						;berbrckung (zwei Gegenwrfel [hher])	 		
rstop0:		ljmp stop0						;berbrckung (Mxchen)

stop7:		mov a,r2							;hole die rechte Zahl
				mov r0,a                   ;und schreibe sie ins Rechenregister
				mov a,#80h						;schreibe die "1" an die vorderste Stelle
rotate7:		rl a                       ;bewege die "1" um 1 nach links
            djnz r0,rotate7            ;so oft, wie das Ergebnis der rechten Zahl
            anl a,r6                   ;und schau, ob dort im Spielregister die 1 ist
            jnz jwin7						;und starte das Gewinnprogramm, wenn es so ist
				ljmp lose				      ;wenn nicht, starte das Verlierprogramm
jwin7:		mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#08h                 ;setze das fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				ljmp win                   ;starte das Gewinnprogramm	

stop6:		mov a,r2							;hole die rechte Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r3							;hole die linke Zahl
				clr c								;(kein Carrybit)
				subb a,r7						;und ziehe sie von der nun rechten Zahl ab
				jnz jlose6                 ;wenn sie "0" ist,
				mov a,r2							;hole die rechte Zahl
				mov r0,a                   ;und schreibe sie ins Zhlregister
				mov a,#80h						;schreibe die "1" an die vorderste Stelle
rotate6:		rl a                       ;bewege die "1" um 1 nach links
            djnz r0,rotate6            ;so oft, wie das Ergebnis der rechten Zahl
            anl a,r6                   ;und schau, ob dort im Spielregister die 1 ist
            jz jlose6						;und starte das Gewinnprogramm, wenn es so ist
				mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#88h                 ;setze das erste und fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				ljmp win                   ;und starte das Gewinnprogramm	
jlose6:		ljmp lose				      ;und starte das Verlierprogramm
				
stop5:		ljmp lose						;keine Gewinnmglichkeit

stop4:		mov a,r5							;hole das zweite Merkregister
				anl a,#70h						;maskiere alles, auer dem dice1-Speicher
				rr a								;dice1-Speicher um 1 nach rechts bewegen
				rr a								;dice1-Speicher um 2 nach rechts bewegen
				rr a								;dice1-Speicher um 3 nach rechts bewegen
				rr a								;dice1-Speicher um 4 nach rechts bewegen
				xrl a,r2							;schau nach, ob irgend ein Bit ungleich ist
				jnz jlose4                 ;wenn ja, starte das Verlierprogramm
				mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#08h                 ;setze das fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				ljmp win							;starte das Gewinnprogramm
jlose4:		ljmp lose						;berbrckung

stop3:		mov a,r2							;hole die rechte Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r3                   ;hole die linke Zahl
				add a,r7 			         ;bilde die Summe aus beiden
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r5							;hole das zweite Merkregister 
				anl a,#0Fh                 ;lsche die 4 ersten Bits
				xrl a,r7							;schau nach, ob irgend ein Bit ungleich ist
				jnz jlose3                 ;wenn ja, starte das Verlierprogramm
				mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#88h                 ;setze das erste und fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				ljmp win							;starte das Gewinnprogramm
jlose3:		ljmp lose						;berbrckung
				
stop2:		mov a,r2							;hole die rechte Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r4							;hole das erste Merkregister
				anl a,#07h						;maskiere alles, auer dem rechten dice3-Speicher				
				xrl a,r7							;schau nach, ob irgend ein Bit ungleich ist
				jnz lwin2                  ;wenn ja, starte die nchste Abfrage
				mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#08h                 ;setze das fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
lwin2:		mov a,r3							;hole die linke Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r4							;hole das erste Merkregister
				anl a,#70h						;maskiere alles, auer dem linken dice3-Speicher
				rr a								;dice1-Speicher um 1 nach rechts bewegen
				rr a								;dice1-Speicher um 2 nach rechts bewegen
				rr a								;dice1-Speicher um 3 nach rechts bewegen
				rr a								;dice1-Speicher um 4 nach rechts bewegen
				xrl a,r7							;schau nach, ob irgend ein Bit ungleich ist
				jnz jlose2                 ;wenn ja, starte das Verlierprogramm
				mov a,r4                   ;hole das erste Merkregister in den Akku
				orl a,#80h                 ;setze das erste Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
jlose2:		ljmp win							;starte das Gewinnprogramm

stop1:		mov a,r2							;hole die rechte Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r3							;hole die linke Zahl
				clr c								;(kein Carrybit)
				subb a,r7						;und ziehe sie von der nun rechten Zahl ab
				jnz jwin1                  ;wenn sie "0" ist,
				ljmp lose						;gewinnt niemand
jwin1:		mov a,r3							;hole die linke Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r2							;hole die rechte Zahl
				clr c								;(kein Carrybit)
				subb a,r7						;und ziehe sie von der nun linken Zahl ab
				jc lwin1							;wenn r7 kleiner war (C=0), gewinnt der rechte
				mov a,r4                   ;d.h, hole das zweite Merkregister in den Akku
				orl a,#08h                 ;setze das erste und fnfte Bit
				mov r4,a                   ;schreibe die Zahl wieder zurck
				ljmp win							;und starte das Gewinnprogramm
lwin1:		mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#80h                 ;und setze das rechte Gewinnbit
				mov r4,a                   ;und schreibe die Zahl wieder zurck
				ljmp win							;starte das Gewinnprogramm

stop0:		mov a,r2							;hole die rechte Zahl in den Akku
				mov r7,a							;um sie ins Rechenregister zu schreiben
				mov a,r3                   ;hole die linke Zahl in den Akku
				add a,r7                   ;und addiere sie mit der nun rechten Zahl
				cjne a,#3,jlose0           ;stimmt das Ergebnis berein,
				mov a,r4                   ;hole das zweite Merkregister in den Akku
				orl a,#88h                 ;setze das erste und fnfte Bit
				mov r4,a                   ;und schreibe die Zahl wieder zurck
				ljmp win                   ;starte das Gewinnprogramm
jlose0:		ljmp lose				      ;berbrckung
			
win:			nop								;warte (bersichtshalber)
on2:			mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#08h                 ;und konzentriere dich auf das fnfte Bit
				jz rbiton                  ;wenn es "1" ist,
				lcall movr                 ;gebe die Zahl vom Register rechts aus
rbiton:		mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jz lbiton                  ;wenn es "1" ist,
				lcall movl                 ;gebe die Zahl vom Register links aus
lbiton:		ljmp zeitb
off2:			mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#08h                 ;und konzentriere dich auf das fnfte Bit
				jz rbitoff                 ;wenn es "1" ist,
				mov p0,#00h						;lsche die rechte Anzeige
rbitoff:		mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jz lbitoff                 ;wenn es "1" ist,
				mov p2,#00h                ;lsche die linke Anzeige
lbitoff:		ljmp zeitb
				
lose:			lcall punkt						;setze die Punkte wenn gewollt
				jnb p0.0,lose0					;ist der rechte Punkt an
				jb p3.3,lose0					;und der rechte Taster nicht gedrckt,
				ljmp learn						;springe zum nchsten Programmteil				
lose0:		mov a,r5                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jnz lose1                  ;wenn es "0" ist,
				jnb p2.0,lose					;und der linke Punkt an ist
				jb p3.2,lose					;und der linke Taster nicht gedrckt,
				ljmp learn						;springe zum nchsten Programmteil
lose1:		jb p3.2,lose					;wenn nicht, ist der linke Taster gedrckt?
				clr p2.0							;wenn nein, lsche den linken Punkt
				ljmp lose						;und springe zurck				
				
learn:		mov a,r4							;nehme die Zahl aus dem Register
				anl a,#77h                 ;setze das erste und das fnfte Bit zurck
				mov r4,a                   ;schreibe sie wieder ins Register
				mov a,r5							;nehme die Zahl aus dem Register
				anl a,#7Fh                 ;setze das erste Bit zurck
				mov r5,a                   ;schreibe sie wieder ins Register
				mov a,r6							;hole die Spieleinstellungen
				anl a,#80h                 ;maskiere alles auer dem ersten Bit
				jnz jlearn1                ;wenn es 1 ist, starte learn1
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#40h                 ;maskiere alles auer dem zweiten Bit
				jnz jlearn2                ;wenn es 1 ist, starte learn2
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#20h                 ;maskiere alles auer dem dritten Bit
				jnz jlearn3                ;wenn es 1 ist, starte learn3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#10h                 ;maskiere alles auer dem vierten Bit
				jnz jlearn1                ;wenn es 1 ist, starte learn1
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#08h                 ;maskiere alles auer dem fnften Bit
				jnz jlearn2                ;wenn es 1 ist, starte learn2
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#04h                 ;maskiere alles auer dem sechsten Bit
				jnz jlearn3                ;wenn es 1 ist, starte learn3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#02h                 ;maskiere alles auer dem siebten Bit
				jnz jlearn3                ;wenn es 1 ist, starte learn3
				mov a,r6                   ;hole die Spieleinstellungen
				anl a,#01h                 ;maskiere alles auer dem achten Bit
				jnz jlearn2                ;wenn es 1 ist, starte learn2
jlearn1:		ljmp learn1                ;berbrckung
jlearn2:		ljmp learn2						;berbrckung
jlearn3:		ljmp learn3						;berbrckung

learn1:		mov a,r2                   ;hole die rechte Zahl
				rl a                       ;verschiebe sie um 1 nach links
				rl a                       ;verschiebe sie um 2 nach links
				rl a                       ;verschiebe sie um 3 nach links
				rl a                       ;verschiebe sie um 4 nach links
				mov r7,a							;und schreibe sie ins Rechenregister
				mov a,r5							;hole das zweite Merkregister
				anl a,#8Fh                 ;lsche den dice1-Speicher
				orl a,r7                   ;berscheibe ihn mit der verschobenen Zahl
				mov r5,a							;und schreibe ihn wieder zurck
				ljmp changegame				;springe zum Spielnderungsprogramm

learn2:		mov a,r2							;hole die rechte Zahl
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r3                   ;hole die linke Zahl
				add a,r7 			         ;bilde die Summe aus beiden
				mov r7,a                   ;und schreibe sie ins Rechenregister
				mov a,r5                   ;hole das zweite Merkregister in den Akku
				anl a,#0F0h                ;lsche die 4 letzten Bits
				orl a,r7                   ;berschreibe sie mit der Summe				
				mov r5,a							;und schreibe das Ergebnis zurck
				ljmp changegame				;springe zum Spielnderungsprogramm

learn3:		mov a,r2							;hole die rechte Zahl
				mov r4,a                   ;und schreibe sie ins erste Merkregister
				mov a,r3                   ;hole die linke Zahl
				rl a                       ;verschiebe sie um 1 nach links
				rl a                       ;verschiebe sie um 2 nach links
				rl a                       ;verschiebe sie um 3 nach links
				rl a                       ;verschiebe sie um 4 nach links
				orl a,r4                   ;schreibe die nun verschobene Zahl
				mov r4,a	                  ;zum ersten Merkregister dazu
				ljmp changegame				;springe zum Spielnderungsprogramm

changegame:	mov r1,#49                 ;49mal Vorgang wiederholen
chloop:		lcall zeit                 ;Zeitverzgerung mit Setzmglichkeit
				jb p3.2,chaskl             ;wenn der rechte Taster nicht mehr gedrckt ist,
				clr p2.0                   ;lsche den rechten Punkt
chaskl:		jb p3.3,chcounter          ;wenn der linke Taster nicht mehr gedrckt ist,
				clr p0.0                   ;lsche den linken Punkt
chcounter:	djnz r1,chloop					;49x(200x10s+11s)=0,1s
				clr p0.0							;lsche den rechten
				clr p2.0	                  ;und den linken Punkt
				mov a,r6							;hole die Zahl aus dem Spielregister
				cjne a,p1,noteqal2         ;und vergleiche sie mit den PINs
				ljmp dice		    			;wenn sie gleich sind, starte das Programm nochmal
noteqal2:	ljmp anfang                ;wenn nicht, sprine zum Anfang
                                       
;===========HALBUNTERPROGRAMME==============================================================;

zeita:		mov r1,#248						;248mal Vorgang ausfhren
zeita0:		lcall zeit                 ;Zeitkonstante
				jb p0.0,zeita1					;wenn danach eine der beiden Punkte gesetzt ist,
				jb p2.0,zeita1             ;springe zur Pinauswertung
				ljmp zeita2						;wenn nicht, mache weiter
zeita1:     mov r6,p1                  ;schreibe die Schalterstellung ins Spielregister
				mov a,r6                   ;und in den Akku
				jnz zeita2                 ;wenn die Schalterstellung 0 ist,
				lcall stuck	   				;weise darauf hin, dass etwas einzustellen
zeita2:		jb p3.3,zeita3             ;wenn der rechte Taster nicht mehr gedrckt ist,
				jnb p0.0,zeita3            ;und der rechte Punkt an ist,
				clr p0.0                   ;lsche den rechten
				clr p2.0                   ;und den linken Punkt
				ljmp dice                  ;und gehe zum Spielentscheidungsteil
zeita3:		jb p3.2,zeita4             ;wenn der linke Taster nicht mehr gedrckt ist,
				jnb p2.0,zeita4            ;und der linke Punkt an ist,
				clr p0.0                   ;lsche den rechten
				clr p2.0                   ;und den linken Punkt
				ljmp dice                  ;und gehe zum Spielentscheidungsteil
zeita4:		djnz r1,zeita0             ;248x(200x10s+20s)=0,5s
				jb p0.7,joff1              ;wenn der Strich an ist, mach ihn aus
				ljmp on1                   ;sonst, mach ihn an	
joff1:		ljmp off1						;berbrckung

zeitb:		mov r1,#74						;74mal Vorgang ausfhren
zeitb0:		lcall zeit                 ;Zeitkonstante
zeitb1:		jb p3.3,zeitb2             ;wenn der rechte Taster nicht mehr gedrckt ist,
				jnb p0.0,zeitb2            ;und der rechte Punkt an ist,
				ljmp learn						;springe zum nchsten Programmteil
zeitb2:		mov a,r5                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jnz zeitb3                 ;wenn es "0" ist,
				jb p3.2,zeitb4             ;und der linke Taster nicht mehr gedrckt ist,
				jnb p2.0,zeitb4            ;und der linke Punkt an ist,
				ljmp learn		            ;springe zum nchsten Programmteil
zeitb3:		jb p3.2,zeitb4					;wenn nicht, ist der linke Taster gedrckt?
				clr p2.0                   ;wenn nein, lsche den linken Punkt
zeitb4:		djnz r1,zeitb0             ;74x(200x10s+10s)=0,15s
				mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jz zeitb5                  ;wenn es "0" ist,
				jb p2.7,joff2              ;und die Anzeige eine Zahl anzeigt,
				jb p2.1,joff2              ;mache sie aus
				ljmp on2                   ;andernfalls, mache sie an
zeitb5:		jb p0.7,joff2              ;wenn die Anzeige eine Zahl anzeigt,
				jb p0.1,joff2              ;mache sie aus
				ljmp on2                   ;andernfalls, mache sie an								
joff2:		ljmp off2						;berbrckung
				
;===========UNTERPROGRAMME==================================================================;

stuck:		mov p0,#12h						;schreibe die "1"
				mov p2,#0F8h               ;schreibe das "P"
				mov r0,#255                ;Zeitkonstante:
stuck0:		mov r1,#255                ;innere Schleife
stuck1:		djnz r1,stuck1		         ;255x2s=510s
				djnz r0,stuck0       	   ;255x255x2s=130ms
				inc r1							;r1 wieder auf 1 setzten (fr djnz spter)
stuck2:		jb p3.3,stuck3    	      ;ist der rechte Taster gedrckt?
				clr p0.0                   ;wenn nein, lsche den rechten Punkt 
				ljmp stuck4          	   ;           und mache weiter
stuck3:		setb p0.0                  ;wenn ja,   setze den rechten Punkt
stuck4:		jb p3.2,stuck5       	   ;ist der linke Taster gedrckt?
				clr p2.0                   ;wenn nein, lsche den linken Punkt
				ljmp stuck6           	   ;           und mache weiter
stuck5:		setb p2.0                  ;wenn ja,   setze den rechten Punkt
stuck6:		jb p0.0,stuck2       	   ;wenn einer der beiden Punkte gesetzt ist,
				jb p2.0,stuck2        	   ;machs nochmal
				mov p0,#00h                ;wenn nicht,
				mov p2,#00h                ;lsche das "P1" wieder
				ret

zeit:			mov r0,#200						;200mal Vorgang ausfhren
zeit0:		jb p3.3,zeit1              ;ist der rechte Taster gedrckt?
				ljmp zeit2                 ;wenn nein, mach weiter
zeit1:		setb p0.0                  ;wenn ja, setze den rechten Punkt
				nop                        ;warte (Zeitausgleich)
zeit2:		jb p3.2,zeit3              ;ist der linke Taster gedrckt?
				ljmp zeit4                 ;wenn nein, mach weiter
zeit3:		setb p2.0                  ;wenn ja, setze den linken Punkt
				nop                        ;warte (Zeitausgleich)
zeit4:		djnz r0,zeit0              ;200x10s=2ms
				ret                        
				
punkt:		jb p3.3,punkt0					;ist der rechte Taster gedrckt?
				ljmp punkt1                ;wenn nein, mach weiter
punkt0:		setb p0.0                  ;wenn ja, setze den rechten Punkt
				nop                        ;warte (Zeitausgleich)
punkt1:		jb p3.2,punkt2             ;ist der linke Taster gedrckt?
				ljmp punkt3                ;wenn nein, mach weiter
punkt2:		setb p2.0                  ;wenn ja, setze den linken Punkt
				nop                        ;warte (Zeitausgleich)
punkt3:		ret

muster:		djnz r0,muster6				;wenn Befehl schon 35mal ausgefhrt wurde,
				djnz r1,muster5				;wenn Befehl schon 35^2mal ausgefhrt wurde,
				mov a,r7							;hole das Rechenregister
				mov r0,a                   ;schreibe den Zyklusteil ins Zhlregister
				mov a,#08h                 ;setzte das fnfte Bit im Akku
muster0:		rl a                       ;und schiebe es so weit nach links,
				djnz r0,muster0            ;wie die Nummer des Zykluses ist				
				mov r0,a							;Zahl im leeren Zhlregister zwischenspeichern
				mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#08h                 ;und konzentriere dich auf das fnfte Bit
				jnz muster2                ;wenn es "0" ist,
				mov a,r0							;Zwischenspeicher abrufen und schauen
				jb p0.0,muster1            ;ob der rechte Punkt nicht an ist,
				mov p0,a                   ;gebe das Muster vom Akku aus
				ljmp muster2               ;und mache weiter
muster1:		mov p0,a		               ;wenn doch, gebe das Muster vom Akku aus
				setb p0.0                  ;und setze den Punkt wieder
muster2:		mov a,r4                   ;hole die Zahl aus dem Register
				anl a,#80h                 ;und konzentriere dich auf das erste Bit
				jnz muster4                ;wenn es "0" ist,
				mov a,r0							;Zwischenspeicher abrufen und schauen
				jb p2.0,muster3            ;ob der linke Punkt nicht an ist,
				mov p2,a                   ;gebe das Muster vom Akku aus
				ljmp muster4               ;und mache weiter
muster3:		mov p2,a		               ;wenn doch, gebe das Muster vom Akku aus
				setb p2.0                  ;und setze den Punkt wieder
muster4:		mov r0,#35                 ;resete die 35mal
				mov r1,#35						;bei beiden Registern
				djnz r7,muster6            ;nehme den nchsten Musterzyklus
				mov r7,#4                  ;wenn er zu ende ist, starte ihn neu
				ljmp muster6					;und kehre zurck zum Hauptprogramm
muster5:		mov r0,#35						;setzte das erste Zhlregister wieder auf 35
muster6:		ret				            

movr:			mov a,r2							;hole die Zahl aus dem Register
				movc a,@a+dptr             ;hole die passende 7-Seg-Darstellung
				jb p0.0,movr0              ;ist der rechte Punkt an?
				mov p0,a                   ;wenn nein, gebe die Zahl aus
				ljmp movr1                 ;           und mache weiter
movr0:		mov p0,a                   ;wenn ja,   gebe die Zahl aus
				setb p0.0                  ;           und setze den Punkt wieder
				nop                        ;warte (Zeitausgleich)
movr1:		ret

movl:			mov a,r3							;hole die Zahl aus dem Register
				movc a,@a+dptr             ;hole die passende 7-Seg-Darstellung
				jb p2.0,movl0              ;ist der linke Punkt an?
				mov p2,a                   ;wenn nein, gebe die Zahl aus
				ljmp movl1                 ;           und mache weiter
movl0:		mov p2,a                   ;wenn ja,   gebe die Zahl aus
				setb p2.0                  ;           und setze den Punkt wieder
				nop                        ;warte (Zeitausgleich)
movl1:		ret

movz:			jb p0.0,movz0					;ist der rechte Punkt an?
				mov p0,#00h                ;wenn nein, lsche die rechte Anzeige
				ljmp movz1                 ;           und mache weiter
movz0:		mov p0,#01h                ;wenn ja,   lsche Alles bis auf den Punkt
movz1:		jb p2.0,movz2              ;ist der linke Punkt an?           
				mov p2,#00h                ;wenn nein, lsche die linke Anzeige
				ljmp movz3                 ;           und mache weiter
movz2:		mov p0,#01h                ;wenn ja,   lsche Alles bis auf den Punkt
movz3:		ret

;===========7-SEG-DARSTELLUNGEN=============================================================;

tabelle:		db 10000000b               ;Segment-Darstellung fr -
				db 00010010b               ;Segment-Darstellung fr 1
				db 10111100b               ;Segment-Darstellung fr 2
				db 10110110b               ;Segment-Darstellung fr 3
				db 11010010b               ;Segment-Darstellung fr 4
				db 11100110b               ;Segment-Darstellung fr 5
				db 11101110b               ;Segment-Darstellung fr 6				
				
end
